<%-- $Id: expression_builder.jsp 6610 2014-11-20 11:48:06Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006, 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	BASE is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.VirtualDb"
	import="net.sf.basedb.core.ReporterCloneTemplate"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.RawDataProperty"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.ReporterList"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.jep.Jep"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="java.util.List"
	import="java.util.LinkedList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
	String title = request.getParameter("title");
	String textarea = request.getParameter("textarea");
	Formula.Type formulaType = Formula.Type.valueOf(request.getParameter("formulatype"));
	RawDataType rawDataType = RawDataTypes.getRawDataType(request.getParameter("rawdatatype"));
	int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"), -1);
	boolean restrictions = Values.getBoolean(request.getParameter("restrictions"));
	int channels = Values.getInt(request.getParameter("channels"));
	final SessionControl sc = Base.getExistingSessionControl(pageContext, true);

	DbControl dc = sc.newDbControl();
	try
	{
		BioAssaySet bas = bioAssaySetId == -1 ? null : BioAssaySet.getById(dc, bioAssaySetId);
		VirtualDb vdb = bas != null ? bas.getExperiment().getVirtualDb() : null;
		ReporterCloneTemplate template = vdb != null && vdb.hasClonedReporters() ? vdb.getReporterCloneTemplate() : null;
				
		IntensityTransform transform = bas == null ? null : bas.getIntensityTransform();
		int maxRawMappings = bas == null ? 1 : bas.getMaxRawMappingsForSpot();

		List<TableColumn> spotProperties = new LinkedList<TableColumn>();
		DynamicUtil.addSpotColumns(spotProperties, dc, channels, transform);
		List<TableColumn> rawProperties = new LinkedList<TableColumn>();
		if (rawDataType != null)
		{
			DynamicUtil.addFormulaColumns(spotProperties, dc, rawDataType, 
				Formula.Type.COLUMN_EXPRESSION, transform, "", "", maxRawMappings == 1);
			if (bas != null) DynamicUtil.addExtraColumns(spotProperties, dc, bas, "", "", "[Xtra] ");
			if (maxRawMappings == 1) DynamicUtil.addRawDataColumns(rawProperties, dc, rawDataType, "", "", "");
		}
		List<TableColumn> reporterProperties = new LinkedList<TableColumn>();
		DynamicUtil.addReporterColumns(reporterProperties, dc, template, "", "", "");
		
		ItemQuery<ReporterList> reporterListQuery = ReporterList.getQuery();
		reporterListQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
		reporterListQuery.order(Orders.asc(Hql.property("name")));
		List<ReporterList> reporterLists = reporterListQuery.list(dc);
		
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="table.js,~expression_builder.js" styles="toolbar.css" />
	<base:body>
		<h1>Expression builder <base:help helpid="expressionbuilder" /></h1>
		<div id="page-data" class="datacontainer"
			data-textarea="<%=textarea%>"
			data-formula-type="<%=formulaType.name() %>"
			data-raw-data-type="<%=rawDataType == null ? "" : rawDataType.getId()%>"
			data-channels="<%=channels%>"
		></div>
	
		<form name="expression">
		<div class="content">
			<table class="input100 " style="width: 100%; height: 100%;">
			<tr>
				<td>
				<tbl:toolbar subclass="bottomborder bg-filled-50">
					<tbl:label
						style="width: 100px;"
						title="Operators:"
					/>
					<tbl:button 
						title="AND"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=" &amp;&amp; "
						data-suffix=""
						tooltip="BOOLEAN AND: expr1 &amp;&amp; expr2"
					/>
					<tbl:button 
						title="OR"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=" || "
						data-suffix=""
						tooltip="BOOLEAN OR: expr1 || expr2"
					/>
					<tbl:button 
						title="NOT"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix="!"
						data-suffix=""
						tooltip="BOOLEAN NOT: !expr1"
					/>
					<tbl:button 
						title="=="
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=" == "
						data-suffix=""
						tooltip="EQUAL: expr1 == expr2"
					/>
					<tbl:button 
						title="!="
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=" != "
						data-suffix=""
						tooltip="INEQUAL: expr1 != expr2"
					/>
					<tbl:button 
						title="&lt;"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=" &lt; "
						data-suffix=""
						tooltip="LESS: expr1 &lt; expr2"
					/>
					<tbl:button 
						title="&lt;="
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=" &lt;= "
						data-suffix=""
						tooltip="LESS OR EQUAL: expr1 &lt;= expr2"
					/>
					<tbl:button 
						title="&gt;="
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=" &gt;= "
						data-suffix=""
						tooltip="MORE OR EQUAL: expr1 &gt;= expr2"
						visible="<%=restrictions%>"
					/>
					<tbl:button 
						title="&gt;"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=" &gt; "
						data-suffix=""
						tooltip="MORE: expr1 &gt; expr2"
					/>
					<tbl:button 
						title="+"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=" + "
						data-suffix=""
						tooltip="ADD: expr1 + expr2"
					/>
					<tbl:button 
						title="-"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=" - "
						data-suffix=""
						tooltip="SUBTRACT: expr1 - expr2"
					/>
					<tbl:button 
						title="*"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=" * "
						data-suffix=""
						tooltip="MULTIPLY: expr1 * expr2"
					/>
					<tbl:button 
						title="/"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=" / "
						data-suffix=""
						tooltip="DIVIDE: expr1 / expr2"
					/>
					<tbl:button 
						title="( )"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix="("
						data-suffix=")"
						tooltip="PARENTHESIS: (expr1)"
					/>
				</tbl:toolbar>
				<tbl:toolbar subclass="bottomborder bg-filled-50">
					<tbl:label
						title="Functions:"
						style="width: 100px;"
					/>
					<%
					Enumeration<String, String> functions = Jep.getFunctions();
					for (int i = 0; i < functions.size(); ++i)
					{
						String function = functions.getKey(i);
						%>
						<tbl:button 
							title="<%=function%>"
							subclass="auto-init"
							data-auto-init="enclose-selection"
							data-prefix="<%=function+"(" %>"
							data-suffix=")"
							tooltip="<%=functions.getValue(i)%>"
						/>
						<%
					}
					%>
					<tbl:label
						title="Constants:"
						style="width: 100px;"
					/>
					<tbl:button 
						title="null"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=""
						data-suffix="null"
						tooltip="The null (unknown) value"
					/>
					<tbl:button 
						title="pi"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=""
						data-suffix="<%=Math.PI%>"
						tooltip="<%="The pi value: " + Math.PI %>"
					/>
					<tbl:button 
						title="e"
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix=""
						data-suffix="<%=Math.E %>"
						tooltip="<%="The base of the natural logarithm: " + Math.E%>"
					/>
				</tbl:toolbar>
				<tbl:toolbar subclass="bottomborder bg-filled-50">
					<%
					if (formulaType != Formula.Type.INTENSITY_EXPRESSION)
					{
						%>
						<td class="label">Spot:
							<select name="spot" id="spot" style="width: 12em;">
							<option value="">- select -
							<%
							for (TableColumn tc : spotProperties)
							{
								if (tc.getJepExpression() != null)
								{
									%>
									<option data-prefix="<%=tc.getJepExpression()%>" 
										title="<%=HTML.encodeTags(tc.getDescription())%>"><%=HTML.encodeTags(tc.getTitle())%>
									<%
								}
							}
							%>
							</select>		
						</td>
						<%
					}
					%>
					<%
					if (rawDataType != null && rawDataType.isStoredInDb() && rawProperties.size() > 0)
					{
						%>
						<td class="label">Raw data:
							<select name="rawdata" id="rawdata" style="width: 12em;">
							<option value="">- select -
							<%
							for (TableColumn tc : rawProperties)
							{
								%>
								<option data-prefix="<%=tc.getJepExpression()%>" 
									title="<%=HTML.encodeTags(tc.getDescription())%>"><%=HTML.encodeTags(tc.getTitle())%>
								<%
							}
							%>
							</select>
						</td>
						<%
					}
					%>
					
					<td class="label">Reporter:
						<select name="reporter" id="reporter" style="width: 12em;">
						<option value="">- select -
							<%
							for (TableColumn tc : reporterProperties)
							{
								%>
								<option data-prefix="<%=tc.getJepExpression()%>" 
									title="<%=HTML.encodeTags(tc.getDescription())%>"><%=HTML.encodeTags(tc.getTitle())%>
								<%
							}
							%>
						</select>
				</tbl:toolbar>
				<tbl:toolbar subclass="bottomborder"
					visible="<%=reporterLists.size() > 0%>">
					<td class="label">
						Reporter lists: 
						
						<select name="listFunction"	>
						<option value="score">score
						<%
						if (restrictions)
						{
							%>
							<option value="inList">in
							<option value="notInList">not in
							<%
						}
						%>
						</select>
						
						<select name="reporterList" id="reporterList">
						<option value="">- select -
							<%
							for (ReporterList list : reporterLists)
							{
								%>
								<option value="<%=list.getId()%>" 
									title="<%=HTML.encodeTags(list.getDescription())%>"><%=HTML.encodeTags(list.getName())%>
								<%
							}
							%>
						</select>
					</td>
				</tbl:toolbar>
				</td>
			</tr>
			<tr style="height: 100%;">
				<td>
				<textarea class="autoheight" name="expression" rows="16"></textarea>
				</td>
			</tr>
			</table>

			</div>
		</form>

		<base:buttongroup subclass="dialogbuttons">
			<base:button 
				id="btnValidate"
				title="Validate&hellip;" 
				image="validate_formula.png"
				tooltip="Validate the expression. EXPERIMENTAL!!" />
			<base:button id="btnSave" title="Ok" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
	}
finally
{
	if (dc != null) dc.close();
}
%>	
